on run (argv)
	
	#log my lowerCase("doh!")
	
	if false then
		(* Save old Clipboard Contents *)
		set oldClipboard to the clipboard
		
		(* Clear Clipboard *)
		set the clipboard to ""
		
		(* Get selected text *)
		set someword to ""
		repeat 23 times
			(* Try to copy the selection to clipboard, might fail, if some more modifiers down (f.e. if you launch this script with FastScripts and a Shortcut that uses option, control or shift..) *)
			try
				tell application "System Events" to keystroke "c" using {command down}
				(* Try to copy the clipboard contents *)
				try
					set someword to the clipboard as text
					#	if (oldClipboard is not equal to someword and someword is not "") then
					exit repeat
					#	end if
				on error (e)
					my logToConsole("Error while copying selection to clipboard (cmd-c): " & e)
				end try
			on error (e)
				my logToConsole("Error while copying the clipboard: " & e)
			end try
			delay 0.1
		end repeat
	end if
	
	(* If copying to and from clipboard worked *)
	if someword is not "" then
		(* String conversion *)
		tell me to set newWord to upperCase(someword)
		log "newWord: " & newWord
		set the clipboard to newWord
		
		(* Paste it *)
	#	delay 1 (* Essential - The cmd-v might been executed BEFORE the clipboard is actually updated! *)
	#	tell application "System Events" to keystroke "v" using {command down}
	end if
	
	(* Clipboard restore *)
#	delay 2 (* Essential - The cmd-V might not been fully executed at this time when we restore the clip! *)
#	set the clipboard to oldClipboard
	
end run

on logToConsole(someText)
	tell AppleScript
		try
			set cmd to "logger -p daemon.notice \"" & "LHS: " & someText & "\""
			do shell script cmd
		on error (e)
			log e
		end try
	end tell
end logToConsole

on logFrontMostProcess()
	(* Find the frontmost process *)
	tell application "System Events" to set fmps to (every process whose frontmost is true) -- and has scripting terminology is true)
	set fmp to first item in fmps
	
	(* Log name *)
	my logToConsole("Frontmost Process: " & name of fmp & " (" & short name of fmp & ")")
end logFrontMostProcess

to upperCase(s)
	set uc to "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
	set lc to "abcdefghijklmnopqrstuvwxyz"
	repeat with i from 1 to 26
		set AppleScript's text item delimiters to character i of lc
		set s to text items of s
		set AppleScript's text item delimiters to character i of uc
		set s to s as text
	end repeat
	set AppleScript's text item delimiters to ""
	return s
end upperCase
