on run (argv)
	(*	try
		set oldClip to the clipboard
		set oldClipSaved to true
	on error (e)
		set oldClipSaved to false
	end try
*)
	
	set the clipboard to my timestamp()
	
	
	#	tell application "System Events" to keystroke "v" using {command down}
	#	delay 1 (* delay, since the pasting could take long - even until restore... (restored clip instead of my timestamp will get pasted! *)
	
	#	if (oldClipSaved) then set the clipboard to oldClip
end run


(* get a time stamp *)
on timestamp()
	set dateNow to current date
	set dateYear to year of dateNow
	set dateMonth to addLeadingZeros(2, (month of dateNow as number))
	set dateDay to addLeadingZeros(2, day of dateNow)
	set dateHour to addLeadingZeros(2, hours of dateNow)
	set dateMinute to addLeadingZeros(2, minutes of dateNow)
	set i to my initials()
	set i to my lowercase(i)
	set dateString to (dateYear & "-" & dateMonth & "-" & dateDay & ",\t" & dateHour & ":" & dateMinute & ", " & i & ":\t") as string
end timestamp

(* Liefert von einer Zahl n leading zeros zurck *)
on addLeadingZeros(zeroesCount, value)
	
	(* nimmt die letzten zeroesCount Stellen des Strings *)
	set newNumber to (text -zeroesCount thru -1 of ("0000000000000000" & value)) (* Da musch drauf kommen: http://macscripter.net/viewtopic.php?id=24533 *)
	log "newNumber: " & newNumber
	
	return (newNumber)
end addLeadingZeros

on initials()
	tell AppleScript
		#get system info
		
		set lun to (long user name of (system info)) # Liefert z.B. "Kretschmer, Heiko"
		
		(* Wenn ein Komma im Usernamen ist -> Blcke vor/zurcktauschen *)
		if (lun contains ",") then
			set elementsCount to my countOfItems(lun, ",")
			set newLun to ""
			set elementCounter to elementsCount
			repeat elementsCount times
				set element to my cut(lun, ",", elementCounter)
				set element to my chomp(element)
				if elementsCount is not equal to elementCounter then
					set newLun to newLun & " "
				end if
				set newLun to newLun & element
				set elementCounter to elementCounter - 1 (* wird bei mehr als einem Komma komisches Ergebnis liefern. Who cares. *)
			end repeat
			set lun to newLun
		end if
		
		(* Von jedem Wort den ersten Buchstaben rausfischen *)
		set elementsCount to my countOfItems(lun, " ")
		set elementCounter to 1
		set i to ""
		repeat elementsCount times
			set element to my cut(lun, " ", elementCounter)
			set element to my chomp(element)
			set i to i & first character of element
			set elementCounter to elementCounter + 1 (* wird bei mehr als einem Komma komisches Ergebnis liefern. Who cares. *)
		end repeat
		
		(* Ergebnis ausgeben *)
		#		log "lun: " & lun
		#		log "initials: " & initials
		return i
	end tell
end initials


# kein echtes chomp! Schmeisst Wort 2 und 3 weg...:-(
on chomp(stringwithspaces)
	set cmd to "echo " & stringwithspaces & " | awk '{printf $1}'"
	return (do shell script cmd)
end chomp


(* log cut("foo:bar:gaga", ":", 1) *)
on cut(str, delim, field)
	set oldAST to AppleScript's text item delimiters
	set AppleScript's text item delimiters to delim
	set elements to text items of str
	set AppleScript's text item delimiters to oldAST
	set res to item field of elements
	return res
end cut


(* set foo to my countOfItems("Blah:Blubb:Narf", ":") returns "3" *)
on countOfItems(str, delim)
	set oldAST to AppleScript's text item delimiters
	set AppleScript's text item delimiters to delim
	set elements to text items of str
	set res to count of elements
	set AppleScript's text item delimiters to oldAST
	return res
end countOfItems

to lowercase(s)
	log "s: " & s
	log "len s: " & length of s
	set uc to "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
	set lc to "abcdefghijklmnopqrstuvwxyz"
	repeat with i from 1 to 26
		set AppleScript's text item delimiters to character i of uc
		set s to text items of s
		set AppleScript's text item delimiters to character i of lc
		set s to s as text
	end repeat
	set AppleScript's text item delimiters to ""
	return s
end lowercase
