(* Script saves selected mails als RTF in an chosen folder *)


tell application "Mail"
	
	set selectedMessages to selection
	
	if (count selectedMessages) is greater than 0 then
		
		(* let user choose a folder to save the messages *)
		tell application "Finder"
			activate
			try
				set chosenFolder to choose folder with prompt "Please select folder to save messages in:"
				log chosenFolder
				tell application "Mail"
					activate
					repeat with oneMessage in selectedMessages
						
						tell oneMessage
							
							(* Nur den Dateinamen konstruieren *)
							# -GEHT NICHT- log all headers
							# 1GEHT!	set t to all headers
							# 1GEHT!	log t
							set oneMessageDateReceived to date received
							tell me to set oneMessageDate to timestampWithDate(oneMessageDateReceived)
							if (length of oneMessageDate is 0) then
								set oneMessageDateSent to date sent
								tell me to set oneMessageDate to timestampWithDate(oneMessageDateSent)
							end if
							set oneMessageFileName to oneMessageDate & "_" & subject & ".rtf" #& "_" & sender
							log oneMessageFileName
							set oneMessageFilePath to POSIX path of chosenFolder & "/" & oneMessageFileName
							
							(* Nun die Mail "holen" *)
							set mailText to all headers
							set mailText to mailText & return & content
							log mailText
							
							##				(* convert line endings *)
							##				tell me to set mailText to changeString of mailText from linefeed to return
							##				
							##				(* Save the mail (no RTF, sorry - TEXT ONLY!) *)
							##				tell me to writeToFileAS(oneMessageFilePath, mailText, true)
							
						end tell (* Message of Mail *)
						
						
						#						save message oneMessage in chosenFolder & ":" & oneMessageFileName #as "rtf"
						save oneMessage in chosenFolder & ":" & oneMessageFileName #as "rtf"
						-- HIER BUGGTS! ---^				
						
						
					end repeat
				end tell (* Mail *)
			on error (e)
				log "Error: " & e
			end try
		end tell (* Finder *)
		
	end if (* If something selected *)
	
end tell (* Mail *)



on writeToFileAS(filePath, txt, overwriteFlag)
	
	tell AppleScript
		
		try
			set fRefNum to (open for access file filePath with write permission)
			
			if (overwriteFlag) then
				set eof fRefNum to 0
				write txt to fRefNum starting at 0
			else
				set fileLen to (get eof fRefNum)
				write txt to fRefNum starting at (fileLen + 1)
			end if
		on error (e)
			log (e)
		end try
		
		(* Try closing file in any case *)
		try
			close access fRefNum
		on error (e)
			log e
		end try
		
	end tell
	
end writeToFileAS


to changeString of t from s to r
	set d to text item delimiters
	set text item delimiters to s
	set t to t's text items
	set text item delimiters to r
	tell t to set t to beginning & ({""} & rest)
	set text item delimiters to d
	t
end changeString

(* get a time stamp *)
on timestampWithDate(givenDate)
	set dateYear to year of givenDate
	set dateMonth to addLeadingZeros(2, (month of givenDate as number))
	set dateDay to addLeadingZeros(2, day of givenDate)
	set dateHour to addLeadingZeros(2, hours of givenDate)
	set dateMinute to addLeadingZeros(2, minutes of givenDate)
	set dateString to (dateYear & "-" & dateMonth & "-" & dateDay & "_" & dateHour & ":" & dateMinute) as string
end timestampWithDate

(* Liefert von einer Zahl n leading zeros zurck *)
on addLeadingZeros(zeroesCount, value)
	
	(* nimmt die letzten zeroesCount Stellen des Strings *)
	set newNumber to (text -zeroesCount thru -1 of ("0000000000000000" & value)) (* Da musch drauf kommen: http://macscripter.net/viewtopic.php?id=24533 *)
	log "newNumber: " & newNumber
	
	return (newNumber)
end addLeadingZeros

