(* This is a practical joke, back in the old times we used this encoding to make sure, no one ever decodes it :-) *)

(* Main *)
on run (argv)
	
	if false then
		(* Save previous clipboard contents *)
		set oldClipboard to the clipboard
		try
			my logToConsole("oldClipboard: " & oldClipboard)
		on error (e)
			my logToConsole("oldClipboard: was not loggable, maybe not TEXT?")
		end try
		
		(* Clear Clipboard *)
		set the clipboard to ""
		
		(* Get selected text *)
		set someword to ""
		repeat 23 times
			(* Try to copy the selection to clipboard, might fail, if some more modifiers down (f.e. if you launch this script with FastScripts and a Shortcut that uses option, control or shift..) *)
			try
				tell application "System Events" to keystroke "c" using {command down}
				(* Try to copy the clipboard contents *)
				try
					set someword to the clipboard as text
					#	if (oldClipboard is not equal to someword and someword is not "") then
					exit repeat
					#	end if
				on error (e)
					my logToConsole("Error while copying selection to clipboard (cmd-c): " & e)
				end try
			on error (e)
				my logToConsole("Error while copying the clipboard: " & e)
			end try
			delay 0.1
		end repeat
	end if
	
	(* If copying to and from clipboard worked *)
	my logToConsole("someword: " & someword)
	if someword is not "" then
		(* Translate text *)
		tell me to set someword to rotRandom(someword)
		set the clipboard to someword
		
		#		(* Paste the translated text *)
		#	tell application "System Events" to keystroke "v" using {command down}
	end if
	
	#	(* Restore previous clipboard *)
	#	delay 2 (* Essential - The cmd-V might not been fully executed at this time when we restore the clip! (THIS IS SERIOUS! DON'T LAUGH!) *)
	#	set the clipboard to oldClipboard
end run


(* ******** Methods ******** *)
to rotRandom(givenString)
	set returnString to ""
	set ascii33to126 to "!\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~"
	
	(* Walk through given string char by char *)
	repeat with char in givenString
		set randomNumber to (random number from 1 to length of ascii33to126)
		set rotChar to character randomNumber of ascii33to126
		set returnString to returnString & rotChar
		
	end repeat
	
	return returnString
end rotRandom

on logToConsole(someText)
	tell AppleScript
		try
			set cmd to "logger -p daemon.notice \"" & "LHS: " & someText & "\""
			do shell script cmd
		on error (e)
			log e
		end try
	end tell
end logToConsole

on logFrontMostProcess()
	(* Find the frontmost process *)
	tell application "System Events" to set fmps to (every process whose frontmost is true) -- and has scripting terminology is true)
	set fmp to first item in fmps
	
	(* Log name *)
	my logToConsole("Frontmost Process: " & name of fmp & " (" & short name of fmp & ")")
end logFrontMostProcess