set the clipboard to my timestamp()

#set oldClip to the clipboard

#tell application "System Events" to keystroke "v" using {command down}

#delay 1 (* delay, since the pasting could take long - even until restore... (restored clip instead of my timestamp will get pasted! *)

#set the clipboard to oldClip


(* get a time stamp *)
on timestamp()
	set dateNow to current date
	set dateYear to year of dateNow
	set dateMonth to addLeadingZeros(2, (month of dateNow as number))
	set dateDay to addLeadingZeros(2, day of dateNow)
	set dateHour to addLeadingZeros(2, hours of dateNow)
	set dateMinute to addLeadingZeros(2, minutes of dateNow)
	set dateString to (dateYear & "-" & dateMonth & "-" & dateDay & " " & dateHour & ":" & dateMinute) as string
end timestamp

(* Liefert von einer Zahl n leading zeros zurck *)
on addLeadingZeros(zeroesCount, value)
	
	(* nimmt die letzten zeroesCount Stellen des Strings *)
	set newNumber to (text -zeroesCount thru -1 of ("0000000000000000" & value)) (* Da musch drauf kommen: http://macscripter.net/viewtopic.php?id=24533 *)
	log "newNumber: " & newNumber
	
	return (newNumber)
end addLeadingZeros
